import java.applet.*;
import java.awt.*;
import java.awt.image.*;
import java.net.*;
import java.util.*;

public class WM_FireworksMenu extends Applet implements Runnable
 {
  // Variabili relative all'applet
  String VER="1.02";
  int _fi=0;
  Image IMG,FG_IMG;
  int INT_IMG[];  
  Dimension apDIM;
  int apDX,apDY;  
  //String REGCODE;
  AR_menu MENU;
  int FG_X,FG_Y,TEXTPOS,BTXTPOS,TEXTF,PW,GRAV,BIG,FWCOL,FWTOP,FWBOTTOM,RANDPW,FLASH;;
  int V1,V2,DUAL,NUM,TEXTH,DIR,TEXTV;
  Color TEXTCOL,COL1,COL2,BTEXTCOL;
  String TEXT=null,BTEXT=null;  
  int SX;
  Font f1 = new Font("TimesRoman",Font.PLAIN,12);
  Font f2;

  // Variabili per il thread e temporizzazione
  Thread RUN;
  long TIME,TFPS;
  int FPS,PFPS;

  // Variabili per il doppio buffer
  Image VSCREEN;   
  Graphics GVSCREEN;

  // Look Up Table
  double LUTC[]=new double[360]; // LUT del coseno
  double LUTS[]=new double[360]; // LUT del seno

  // Variabili per l'effetto fireworks
  int dFX,dFY;
  int MAX_PAR;
  int MAX_BOOM;
  AR_particle PART[][]; // botti [numero di botti massimi contemporanei] e [numero di particelle per botto]
  AR_particle ROCKET[]; // razzi [numero di razzi]
  int RKT_POS[];

  public void init()
   {
     // Inizializza applet
    // setSize(320,200);
    apDIM=getSize();
    apDX=apDIM.width;         
    apDY=apDIM.height;
    // Carica lo sfondo e i parametri
    try 
     {
      // Inizializza le immagini	
      MediaTracker tr=new MediaTracker(this);
      PixelGrabber pg;     	
      // Codice di registrazione
      //REGCODE =getParameter("regcode");
      // Parametri applet                       
      IMG     =getImage(getDocumentBase(),getParameter("bgimg")); // Carica tutte le immagini      
      FG_IMG  =getImage(getDocumentBase(),getParameter("fgimg"));
      FG_X    =Integer.parseInt(getParameter("fgimgx"));
      FG_Y    =Integer.parseInt(getParameter("fgimgy"));      
      PW      =Integer.parseInt(getParameter("fireworkspow"));
      RANDPW =Integer.parseInt(getParameter("fireworksrpow"));
      GRAV    =Integer.parseInt(getParameter("fireworksgra"));
      MAX_PAR =Integer.parseInt(getParameter("fireworkspart"));
      MAX_BOOM=Integer.parseInt(getParameter("fireworksqua"));
      FWTOP   =Integer.parseInt(getParameter("fireworkstop"));
      FWBOTTOM=Integer.parseInt(getParameter("fireworksbottom"));
      FLASH   =Integer.parseInt(getParameter("fireworksflash"));
      BIG     =Integer.parseInt(getParameter("fireworksbig"));
      FWCOL   =Integer.parseInt(getParameter("fireworkscol"));
      // Parametri generali
      BTEXT   =getParameter("bottomtext");
      BTEXTCOL=new Color(Integer.parseInt(getParameter("bottomtextcol"),16));
      BTXTPOS =Integer.parseInt(getParameter("bottomtextalign"));
      tr.addImage(IMG,0); // Per ogni PICS[i]
      tr.waitForID(0);
      INT_IMG=new int[apDX*apDY];

      pg=new PixelGrabber(IMG,0,0,apDX,apDY,INT_IMG,0,apDX);
      pg.grabPixels();
      tr.addImage(FG_IMG,1);
      tr.waitForID(1);
     } catch(InterruptedException e) {};

    /*if(REGCODE.length()>=10)
     {
      if(getDocumentBase().toString().toUpperCase().startsWith("HTTP://"))
       {
        if(getDocumentBase().toString().substring(7).toUpperCase().indexOf(AR_util.AR_verify(REGCODE))!=-1) _fi=0;
       } 
      else 
       {
        if(getDocumentBase().toString().toUpperCase().indexOf(AR_util.AR_verify(REGCODE))!=-1) _fi=0;
       }
      if(AR_util.AR_verify(REGCODE).equals("")) _fi=1;
     } 
    else _fi=1;*/

    TEXT="";
    TEXTH=36;
    DIR=0;
    TEXTV=1;
    TEXTCOL=new Color(0,120,255);
    TEXTF=0;
    if(TEXTF==0) f2=new Font("TimesRoman",Font.BOLD,TEXTH);
    if(TEXTF==1) f2=new Font("Arial",Font.BOLD,TEXTH);
    if(TEXTF==2) f2=new Font("Courier",Font.BOLD,TEXTH);  
    if(_fi==1) TEXT="http://www.valarsoft.com";
    if(DIR==1) SX=-getFontMetrics(f2).stringWidth(TEXT); else SX=apDX;
    if(_fi==1) TEXTPOS=apDY>>1;

    // Inizializza menu
    MENU = new AR_menu(apDX,apDY,this);
    
    // Inizializza il doppio buffer
    VSCREEN=createImage(apDX,apDY);
    GVSCREEN=VSCREEN.getGraphics();
    
    // Inizializza particelle
    PART = new AR_particle[MAX_BOOM][MAX_PAR];
    ROCKET = new AR_particle[MAX_BOOM];
    RKT_POS = new int[MAX_BOOM];
    for(int k=0;k<MAX_BOOM;k++) for(int pi=0;pi<MAX_PAR;pi++) { PART[k][pi] = new AR_particle(); PART[k][pi].passi=22; }    
    for(int k=0;k<MAX_BOOM;k++)
     {
      ROCKET[k] = new AR_particle(AR_util.AR_rand(apDX)*65536,(apDY+AR_util.AR_rand(apDY>>2))*65536,(apDY>>1),AR_util.AR_rand(40)+250,0,0);
      RKT_POS[k] = AR_util.AR_rand(FWBOTTOM-FWTOP)+FWTOP;
     }
     
    // Inizializza le LUT
    AR_util.AR_setLUT();
   }

  public void start()
   {
    RUN=new Thread(this);
    RUN.setPriority(RUN.MIN_PRIORITY);
    RUN.start();
   }

  public void run()
   {
    int tmp,p=0,aux=0,ang=0;
    double frax=0;
       	
    getGraphics().drawString("Loading...",1,apDY-4);   	
    while(true)
     {      
      // Corpo del programma
      // AR_clear(GVSCREEN,Color.black);
      //GVSCREEN.drawImage(IMG,0,0,null);

      AR_fireworks(INT_IMG,GVSCREEN); // Crea fireworks (si potrebbe anche chiamare genericamente AR_particle())
      
      MENU.drawMenu(GVSCREEN); // Manda menu a video
      GVSCREEN.setFont(f1);
      GVSCREEN.setColor(BTEXTCOL);
      System.gc();      
      if(_fi==1) GVSCREEN.drawString("Webmatic FireworksMenu "+VER+" (demo)",1,apDY-4);
      else
       {       	
       	if(BTXTPOS==0) GVSCREEN.drawString(BTEXT,1,apDY-4); // Left
       	if(BTXTPOS==1) GVSCREEN.drawString(BTEXT,(apDX-getFontMetrics(f1).stringWidth(BTEXT))/2,apDY-4); // Center
       	if(BTXTPOS==2) GVSCREEN.drawString(BTEXT,apDX-getFontMetrics(f1).stringWidth(BTEXT),apDY-4); // Right
       }
      GVSCREEN.drawImage(FG_IMG,FG_X,FG_Y,null); // Immagine in primo piano (logo)
      GVSCREEN.setFont(f2);
      GVSCREEN.setColor(TEXTCOL);
      GVSCREEN.drawString(TEXT,SX,TEXTPOS);
      GVSCREEN.setColor(BTEXTCOL);
      if(DIR==1) 
       {
        SX+=TEXTV;
        if(SX>=apDX) SX=-getFontMetrics(f2).stringWidth(TEXT);
       }
      else
       {
        SX-=TEXTV;
        if(SX<=-getFontMetrics(f2).stringWidth(TEXT)) SX=apDX;
       }
      GVSCREEN.setFont(f1);
      AR_waitfps(60);           // Sincronizza i frame per secondo
      paint(getGraphics());     // Manda a video
      try
       {
        RUN.yield();
       } catch(Exception e) {};   
     }
   }

  public void stop()
   {
    RUN.stop();
   }

  public String getAppletInfo()
   {
    return "Webmatic FireworksMenu "+VER+" by Amuso Raffaele - http://www.valarsoft.com";
   }

  public final boolean mouseUp(Event e, int x, int y)
   {
    try
     {          
      URL link;
      String target="";      
      if(_fi==0)
       {       	
        if(MENU.over>=0 && MENU.over<MENU.NUM)
         {
          link=new URL(getCodeBase(),MENU.url[MENU.over]); target=MENU.target[MENU.over];
          if(MENU.url[MENU.over].compareTo("")!=0) getAppletContext().showDocument(link,target);
         }
       } 
      else
       {
        if(MENU.over>=0 && MENU.over<MENU.NUM) { link=new URL(getCodeBase(),MENU.url[MENU.over]); target=MENU.target[MENU.over]; }
        else { link=new URL(getCodeBase(),"http://www.valarsoft.com"); target="_blank"; }
        //if(MENU.url[MENU.over].compareTo("")!=0)
         getAppletContext().showDocument(link,target);
       }
     } catch(MalformedURLException ex) {};
    return true;
   }

  public final boolean mouseMove(Event e, int x, int y)
   {
    if(MENU.MODE==0) MENU.overMenu(y);
    if(MENU.MODE==1) MENU.overMenu(x);
    return true;
   }

  public final boolean mouseExit(Event e, int x, int y)
   {
    MENU.over=-1;
    return true;
   }


  public void paint(Graphics g)
   {
    g.drawImage(VSCREEN,0,0,null); // Stampa il buffer nel video (potrei stampare piu' di un buffer, basta duplicare la linea e riferirsi ad un altro buffer buf)
   }

  // ================= LIBRERIA =======================================================

  public synchronized final void AR_waitfps(int maxfps) // Sincronizza i frame per secondo
   {
    long ms=1000/maxfps;
    long mdif=System.currentTimeMillis()-TIME;

    if(mdif<ms)
     {
      try 
       { 
        RUN.sleep(ms-mdif); 
       } catch (InterruptedException e) {};
     }
    // Stampa fps
    TFPS+=System.currentTimeMillis()-TIME;
    FPS++;
    if(TFPS>=1000) { TFPS=0; PFPS=FPS; FPS=0; }
    if(_fi==1) GVSCREEN.drawString("fps: "+String.valueOf(PFPS),apDX-getFontMetrics(f1).stringWidth("fps: "+String.valueOf(PFPS)),11);
    // Coglie l'attimo
    TIME=System.currentTimeMillis();
   }

  public void AR_setLUT() // Prepara le LUT del seno e del coseno
   {
    int i; 
 
    for(i=0;i<360;i++)
     {
      LUTC[i]=Math.cos(AR_util.AR_rad(i));
      LUTS[i]=Math.sin(AR_util.AR_rad(i));
     }
   }

  public void AR_clear(Graphics g, Color c)
   {
    g.setColor(c);
    g.fillRect(0,0,apDX,apDY);
   }

  public void AR_putpx(Graphics g, int x, int y, Color c)
   {
    // Disegna un pixel
    g.setColor(c);
    g.drawLine(x,y,x,y);
   }

  public Image AR_filter_light(Image img, int li)
   {
    // Filtro globale su un immagine non in tempo reale
    // da usare per precalcolare immagini filtrate
    // questo filtro schiarisce o scurisce l'immagine
    int x,y,c,r,g,b;
    int int_img[]=new int[apDX*apDY];

    try 
     {
      PixelGrabber pg=new PixelGrabber(img,0,0,apDX,apDY,int_img,0,apDX);
      pg.grabPixels();
     } catch (InterruptedException e) {};
    for(x=0;x<apDX;x++)
     for(y=0;y<apDY;y++)
      {
       c=int_img[x+y*apDX]; // Prende il colore dell'immagine
       r=(c>>16) & 0xff;
       g=(c>>8)  & 0xff;
       b=c       & 0xff; 
       r*=li; if(r>=255) r=255;
       g*=li; if(g>=255) g=255;
       b*=li; if(b>=255) b=255;
       int_img[x+y*apDX]=(255<<24)|(r<<16)|(g<<8)|b;
      } 
    return createImage(new MemoryImageSource(apDX,apDY,int_img,0,apDX));
   }

  public void AR_line(int cx, int cy, int cz, int rx, int ry, int rz, Color Col, int Xa, int Ya, int Za, int Xb, int Yb, int Zb, int zo, Graphics g)
   {
    // Stampa una linea con
    // cx,cy,cz posizione
    // rx,ry,rz gradi per le rotazioni lungo gli assi x,y,z
    // zo fattore di zoom
    // Col colore delle stelle
    // g schermo dove stampare il tutto
    int x1,y1,z1,x2,y2,z2;                            // Punti da unire con una linea
    double xa,ya,za,xb,yb,zb,xa1,ya1,za1,xb1,yb1,zb1; // Variabili per i calcoli
    double ta,tb;                                     // Variabili per la prospettiva
    int d=128;                                        // Distanza dall'occhio

    x1=Xa*zo; y1=Ya*zo; z1=Za*zo+cz;
    x2=Xb*zo; y2=Yb*zo; z2=Zb*zo+cz;
    // Rotazione lungo asse X
    ya1=y1*LUTC[rx]+z1*LUTS[rx];
    za1=y1*LUTS[rx]-z1*LUTC[rx];
    yb1=y2*LUTC[rx]+z2*LUTS[rx];
    zb1=y2*LUTS[rx]-z2*LUTC[rx];
    // Rotazione lungo asse Y
    xa1=x1*LUTC[ry]+za1*LUTS[ry];
    za=x1*LUTS[ry]-za1*LUTC[ry];
    xb1=x2*LUTC[ry]+zb1*LUTS[ry];
    zb=x2*LUTS[ry]-zb1*LUTC[ry];
    // Rotazione lungo asse Z
    xa=xa1*LUTC[rz]+ya1*LUTS[rz];
    ya=xa1*LUTS[rz]-ya1*LUTC[rz];
    xb=xb1*LUTC[rz]+yb1*LUTS[rz];
    yb=xb1*LUTS[rz]-yb1*LUTC[rz];
    // Proiezione prospettica
    ta=za+d;
    tb=zb+d;
    x1=(int)(d*xa/ta);
    y1=(int)(d*ya/ta);
    x2=(int)(d*xb/tb);
    y2=(int)(d*yb/tb);
    g.setColor(Col);
    g.drawLine(x1+cx,y1+cy,x2+cx,y2+cy);   
   }

  public void AR_wire_poly(int cx, int cy, int cz, int rx, int ry, int rz, Color Col, AR_poly poly, int zo, Graphics g)
   {
    for(int i=0;i<poly.nlines-1;i++)
     {
      AR_line(cx,cy,cz,rx,ry,rz,Col,poly.punto[i].x,poly.punto[i].y,poly.punto[i].z,poly.punto[i+1].x,poly.punto[i+1].y,poly.punto[i+1].z,zo,g);
     }
   }

  public void AR_fill_poly(int cx, int cy, int cz, int rx, int ry, int rz, Color Col, AR_poly poly, int zo, Graphics g)
   {
    // Stampa una linea con
    // cx,cy,cz posizione
    // rx,ry,rz gradi per le rotazioni lungo gli assi x,y,z
    // zo fattore di zoom
    // Col colore delle stelle
    // g schermo dove stampare il tutto
    int X[] = new int[poly.nlines];                   // Punti che formeranno il poligono
    int Y[] = new int[poly.nlines];
    int x1,y1,z1;                                     // Punti da unire con una linea
    double xa,ya,za,xb,yb,zb,xa1,ya1,za1,xb1,yb1,zb1; // Variabili per i calcoli
    double ta;                                        // Variabili per la prospettiva
    int d=128;                                        // Distanza dall'occhio

    for(int i=0;i<poly.nlines;i++)
     {
      x1=poly.punto[i].x*zo; y1=poly.punto[i].y*zo; z1=poly.punto[i].z*zo+cz;
      // Rotazione lungo asse X
      ya1=y1*LUTC[rx]+z1*LUTS[rx];
      za1=y1*LUTS[rx]-z1*LUTC[rx];
      // Rotazione lungo asse Y
      xa1=x1*LUTC[ry]+za1*LUTS[ry];
      za=x1*LUTS[ry]-za1*LUTC[ry];
      // Rotazione lungo asse Z
      xa=xa1*LUTC[rz]+ya1*LUTS[rz];
      ya=xa1*LUTS[rz]-ya1*LUTC[rz];
      // Proiezione prospettica
      ta=za+d;
      X[i]=(int)(d*xa/ta)+cx;
      Y[i]=(int)(d*ya/ta)+cy;
     }
    g.setColor(Col);
    g.fillPolygon(X,Y,poly.nlines-1);
   }

  public AR_stars AR_stars(int cx, int cy, int cz, int rx, int ry, int rz, Color Col, AR_stars sp, Graphics g)
   {
    // Simula un campo stellare con
    // cx,cy centro di espansione
    // cz distanza del centro di espansione
    // rx,ry,rz gradi per le rotazioni lungo gli assi x,y,z
    // Col colore delle stelle
    // sp struttura di tipo AR_stars contenente i dati per le stelle
    // g schermo dove stampare il tutto
    int x,y,x1,y1,z1;            // Punto da disegnare
    double xa,ya,za,xa1,ya1,za1; // Variabili per i calcoli
    double t;                    // Variabile per la prospettiva
    int d=128,dis;               // Distanza dall'occhio

    for(int i=0;i<sp.nstars-1;i++) // Per ogni stella
     {
      x1=sp.star[i].x;
      y1=sp.star[i].y;
      z1=sp.star[i].z+cz;
      // Rotazione lungo asse X
      ya1=y1*LUTC[rx]+z1*LUTS[rx];
      za1=y1*LUTS[rx]-z1*LUTC[rx];
      // Rotazione lungo asse Y
      xa1=x1*LUTC[ry]+za1*LUTS[ry];
      za=x1*LUTS[ry]-za1*LUTC[ry];
      // Rotazione lungo asse Z
      xa=xa1*LUTC[rz]+ya1*LUTS[rz];
      ya=xa1*LUTS[rz]-ya1*LUTC[rz];
      // Proiezione prospettica
      t=za+d;
      if(t==0) t=1; // Evita la divisione per 0
      x1=(int)(d*xa/t); y1=(int)(d*ya/t);
      x=x1+cx; y=y1+cy;
      sp.star[i].z--; // Fa "avanzare" le stelle
      // Controlli
      if(x>apDX || x<0 || y>apDY || y<0 || z1<-200)
       {
        sp.star[i].x=AR_util.AR_rand(apDX)-(apDX>>1);
        if(sp.star[i].x==0) sp.star[i].x=1;
        sp.star[i].y=AR_util.AR_rand(apDY)-(apDY>>1);
        sp.star[i].z=AR_util.AR_rand(400)-200;
       }
      dis=-sp.star[i].z>>7;
      if(dis==0) dis=1;
      g.setColor(Col);
      g.fillOval(x,y,dis,dis);   
     }
    return sp;
   }

  public AR_drops AR_rain(int spe, int vel, Color Col, AR_drops dr, Graphics g)
   {
    // Simula la pioggia con
    // spe spessore delle gocce
    // Col colore delle gocce
    // sp struttura di tipo AR_drops contenente i dati per le gocce
    // g schermo dove stampare il tutto
    int x,y; // Variabili per la stampa di una goccia

    for(int i=0;i<dr.ndrops-1;i++) // Per ogni stella
     {
      x=dr.drop[i].x;
      y=dr.drop[i].y;
      dr.drop[i].y+=vel; // Fa "cadere" la pioggia
      // Controlli
      if(x>apDX || x<0 || y>apDY || y<0)
       {
        dr.drop[i].x=AR_util.AR_rand(apDX);
        dr.drop[i].y=AR_util.AR_rand(apDY)-apDY;
       }
      g.setColor(Col);
      g.fillRect(x,y,1,8);   
     }
    return dr;
   }

  public void AR_init_rocket(int n)   
   {    
    ROCKET[n].x=AR_util.AR_rand(apDX)*65536;
    ROCKET[n].y=(apDY+AR_util.AR_rand(apDY>>2))*65536;
    ROCKET[n].vx=0;
    ROCKET[n].vy=0;
    ROCKET[n].passi=0;
    ROCKET[n].ac=apDY>>1;
    ROCKET[n].an=AR_util.AR_rand(40)+250;
    ROCKET[n].gr=0;      
    ROCKET[n].fl=0;      
    RKT_POS[n]=AR_util.AR_rand(FWBOTTOM-FWTOP)+FWTOP;
   }

  public void AR_init_fireworks(int n, int pow, int x, int y)   
   {    
    int c;
    
    if(FWCOL==0) c=AR_util.AR_rand(4)+1;
    else c=FWCOL;
    for(int k=0;k<MAX_PAR;k++)
      {
       PART[n][k].x=x*65536;
       PART[n][k].y=y*65536;
       PART[n][k].vx=0;
       PART[n][k].vy=0;
       PART[n][k].passi=0;
       PART[n][k].ac=AR_util.AR_rand(pow)+1;
       PART[n][k].an=AR_util.AR_rand(359);
       //PART[n][k].an=AR_util.AR_rand(100)+240;
       PART[n][k].gr=GRAV;            
       if(FWCOL==0) PART[n][k].col=c;
       else PART[n][k].col=c;
      }
   }

  public void AR_fireworks(int sfondo[], Graphics gr)
   {
    // Effetto Fireworks su un'immagine con
    // ...
    int x,y,c,v;
    int r,g,b;
    int lu,co;
    int img[]=new int[apDX*apDY];

    lu=0;
    co=0;
    for(int n=0;n<MAX_BOOM;n++) if(PART[n][0].passi<=2) { lu=PART[n][0].passi; co=PART[n][0].col; }
    for(x=0;x<apDX;x++)	
     {
      for(y=0;y<apDY;y++)
       {
        if(FLASH==0) img[x+y*apDX]=sfondo[x+y*apDX];        
        else
         {
          if(lu<=2)
           {
            c=sfondo[x+y*apDX]; // Prende il colore dell'immagine
            r=(c>>16) & 0xff;
            g=(c>>8)  & 0xff;
            b=c       & 0xff;
            if(co==1)
             {
              r=r<<lu;
              g=g<<lu;
             } 
            if(co==2) r=r<<lu;
            if(co==3) g=g<<lu;
            if(co==4)
             {
              g=g<<lu;
              b=b<<lu;
             }
            if(co==5)
             {
              r=r<<lu;
              g=g<<lu;
              b=b<<lu;
             }
            if(r>255) r=255;
            if(g>255) g=255;
            if(b>255) b=255;
            img[x+y*apDX]=(255<<24)|(r<<16)|(g<<8)|b;
           }
          else img[x+y*apDX]=sfondo[x+y*apDX];        
         } 
       }
     }
    for(int n=0;n<MAX_BOOM;n++)
     {
      for(int k=0;k<MAX_PAR;k++)
       {
       	if(ROCKET[n].fl==1)
       	 {
          if((PART[n][k].x>>16)>=0 && (PART[n][k].x>>16)<apDX-1 && (PART[n][k].y>>16)>=0 && (PART[n][k].y>>16)<apDY-1)
           {       	
     	    c=sfondo[(PART[n][k].x>>16)+(PART[n][k].y>>16)*apDX]; // Prende il colore dell'immagine
            r=(c>>16) & 0xff;
            g=(c>>8)  & 0xff;
            b=c       & 0xff;
       	    if(PART[n][k].passi>16)
       	     {
       	      v=512-((PART[n][k].passi-16)*80);
       	      v=v>>1;
       	     }
       	    else v=256; 
       	    if(PART[n][k].col==1) // Yellow
       	     {
              r=(255*(v)+r*(255-v))/255;
              g=(255*(v)+g*(255-v))/255;
       	      b=(0  *(v)+b*(255-v))/255;
       	     }
       	    if(PART[n][k].col==2) // Red
       	     {
              r=(255*(v)+r*(255-v))/255;
              g=(0  *(v)+g*(255-v))/255;
       	      b=(0  *(v)+b*(255-v))/255;
       	     }
       	    if(PART[n][k].col==3) // Green
       	     {
              r=(0  *(v)+r*(255-v))/255;
              g=(255*(v)+g*(255-v))/255;
       	      b=(0  *(v)+b*(255-v))/255;
       	     }
       	    if(PART[n][k].col==4) // Blue
       	     {
              r=(0  *(v)+r*(255-v))/255;
              g=(255*(v)+g*(255-v))/255;
       	      b=(255*(v)+b*(255-v))/255;
       	     }
       	    if(PART[n][k].col==5) // White
       	     {
              r=(255*(v)+r*(255-v))/255;
              g=(255*(v)+g*(255-v))/255;
       	      b=(255*(v)+b*(255-v))/255;
       	     }       	     
       	    c=(255<<24)|(r<<16)|(g<<8)|b;	
       	    img[(PART[n][k].x>>16)+(PART[n][k].y>>16)*apDX]=c; 
       	    if(BIG==1)
       	     {
              img[((PART[n][k].x>>16)+1)+(PART[n][k].y>>16)*apDX]=c; 
              img[(PART[n][k].x>>16)+((PART[n][k].y>>16)+1)*apDX]=c; 
              img[((PART[n][k].x>>16)+1)+((PART[n][k].y>>16)+1)*apDX]=c; 
             }
           }
         }     
       }
     }
    for(int n=0;n<MAX_BOOM;n++) for(int k=0;k<MAX_PAR;k++) PART[n][k].AR_accelera(); 
    for(int n=0;n<MAX_BOOM;n++) if(PART[n][0].passi==23) AR_init_rocket(n);
    for(int n=0;n<MAX_BOOM;n++)
     {
      if(ROCKET[n].fl==0)
       {
        if((ROCKET[n].x>>16)>=0 && (ROCKET[n].x>>16)<apDX-1 && (ROCKET[n].y>>16)>=0 && (ROCKET[n].y>>16)<apDY-1)
         {
          img[(ROCKET[n].x>>16)+(ROCKET[n].y>>16)*apDX]=(255<<24)|(255<<16)|(255<<8)|255;
          if(BIG==1)
       	   {
            img[((ROCKET[n].x>>16)+1)+(ROCKET[n].y>>16)*apDX]=(255<<24)|(255<<16)|(255<<8)|255;
            img[(ROCKET[n].x>>16)+((ROCKET[n].y>>16)+1)*apDX]=(255<<24)|(255<<16)|(255<<8)|255;
            img[((ROCKET[n].x>>16)+1)+((ROCKET[n].y>>16)+1)*apDX]=(255<<24)|(255<<16)|(255<<8)|255;
           }
         }
        ROCKET[n].AR_accelera();
        ROCKET[n].passi=0;
        if((ROCKET[n].y>>16)<RKT_POS[n] || ROCKET[n].vy>0)
         {
          if(RANDPW==1) PW=AR_util.AR_rand(80)+20;
          ROCKET[n].fl=1;
          AR_init_fireworks(n,PW,ROCKET[n].x>>16,ROCKET[n].y>>16);
         }
       }
     }
    gr.drawImage(createImage(new MemoryImageSource(apDX,apDY,img,0,apDX)),0,0,null);
   }
 }

class AR_util
 { 
  static int ILUTC[]=new int[360]; // LUT del coseno
  static int ILUTS[]=new int[360]; // LUT del seno
 
  public static void AR_setLUT() // Prepara le LUT del seno e del coseno
   {
    int i; 
 
    for(i=0;i<360;i++)
     {
      ILUTC[i]=(int)(Math.cos(AR_util.AR_rad(i))*65536);
      ILUTS[i]=(int)(Math.sin(AR_util.AR_rad(i))*65536);
     }
   }

  public static int AR_rand(int max)
   {
    // Torna un numero casuale tra 0 e max (compreso)
    max++; 
    return (int)(Math.random()*max);
   }

  public static double AR_deg(double rad)
   {
    // Trasforma un angolo da radianti a gradi
    return ((double)(180*rad/Math.PI));
   }

  public static double AR_rad(double deg)
   {
    // Trasforma un angolo da gradi a radianti
    return ((double)(Math.PI*deg/180));
   }

  public static String AR_verify(String str)
   {
    String aux="";
    char ch;
    int n,i,len,p,sh;
    int pa[]={16, 12, 9, 3, 17, 8, 5};
    int sp=7,sd=13,pl=7;

    p=0;
    str=str.substring(1,str.length());
    len=str.length();
    try
     {
      while(p<len)
       {
        if(str.charAt(p)=='0' || str.charAt(p)=='1' || str.charAt(p)=='2' || str.charAt(p)=='3' || str.charAt(p)=='4' || str.charAt(p)=='5' || str.charAt(p)=='6' || str.charAt(p)=='7' || str.charAt(p)=='8' || str.charAt(p)=='9' || str.charAt(p)=='-' || str.charAt(p)=='*')
         {
     	    if(str.charAt(p)=='0' || str.charAt(p)=='1' || str.charAt(p)=='2' || str.charAt(p)=='3' || str.charAt(p)=='4' || str.charAt(p)=='5' || str.charAt(p)=='6' || str.charAt(p)=='7' || str.charAt(p)=='8' || str.charAt(p)=='9') // a 3 cifre
   	     {
   	      n=Integer.parseInt(str.substring(p,p+3));
   	      aux=aux+(char)n;
   	      p+=3;
   	     }
   	    if(p>=len) break; 
   	    if(str.charAt(p)=='*') // a 2 cifre
   	     {
   	      n=Integer.parseInt(str.substring(p+1,p+3));   	  
   	      aux=aux+(char)n;
   	      p+=3;
   	     }
   	    if(p>=len) break; 
          if(str.charAt(p)=='-') // ad una cifra
           {
   	      n=Integer.parseInt(str.substring(p+1,p+2));
   	      aux=aux+(char)n;
   	      p+=2;
   	     }
         }
        else
         {
          aux=aux+str.charAt(p);	
          p++;   	  
         }
       }
      len=aux.length();
      if(len%2==0) sh=sp+len;
      else sh=sd-len; 
      str=aux;
      aux="";
      for(i=0;i<len;i++) 
       {
        n=str.charAt(i);
        n-=sh;
        n-=pa[i%pl];
        aux=aux+(char)n;      
       }
     }
    catch(Exception e)
     {
      return "";
     }
    return aux; 
   }   
 }

class AR_spot // Classe che definisce un punto nel 3D
 {
  int x,y,z; // coordinate punto

  AR_spot()
   {
    x=0;
    y=0;
    z=0;
   }

  AR_spot(int x, int y, int z)
   {
    this.x=x;
    this.y=y;
    this.z=z;
   }
 }

class AR_stars // Classe che definisce un insieme di punti nel 3D
 {
  int nstars;                        // Numero stelle
  AR_spot star[] = new AR_spot[256]; // Max 256 stelle

  public AR_stars(int n, int rx, int ry) // Costruttore
   {
    nstars=n;
    for(int i=0;i<n;i++) star[i] = new AR_spot(AR_util.AR_rand(rx)-(rx>>1),AR_util.AR_rand(ry)-(ry>>1),AR_util.AR_rand(400)-400);
   }
 }

class AR_drops // Classe che definisce un insieme di gocce nel piano
 {
  int ndrops;                         // Numero gocce
  AR_spot drop[] = new AR_spot[512];  // Max 512 gocce

  public AR_drops(int n, int rx, int ry) // Costruttore
   {
    ndrops=n;
    for(int i=0;i<n;i++) drop[i] = new AR_spot(AR_util.AR_rand(rx)-rx,AR_util.AR_rand(ry)-ry,0);
   }
 }

class AR_poly // Classe che definisce un poligono 3D
 {
  int nlines;                         // Numero di linee
  AR_spot punto[] = new AR_spot[256]; // Max 256 linee

  public AR_poly(int n, AR_spot pun[]) // Costruttore
   {
    nlines=n;
    for(int i=0;i<n;i++) punto[i] = new AR_spot(pun[i].x,pun[i].y,pun[i].z);
   }
 }
 
class AR_menu extends Applet // Classe che gestisce un menu
 {
  String titolo[],MENUTITLE; // Titolo voce
  String url[],MENUURL;      // Link
  String target[],MENUTARGET;// Target del link  
  Font f;                    // Carattere del menu
  Color col1,col2,col3,col4; // Colore di: Testo normale, testo selezionato, ombra, fill
  int NUM,START,SHAD;        // Numero voci del menu, posizione iniziale menu, menu con ombra
  int over,SELMODE,MODE;     // Voce evidenziata e modo di evidenziarla, menu orizzontale o verticale
  int wmax=0,hmax=0;         // Larghezza e altezza massima delle voci
  int sdis;                  // Distanza dell'ombra in pixel
  int fgap;                  // Gap per i caratteri
  int tipofont,hfont,spaz,align,inv,offset[];
  int apDX,apDY;             // Dimensioni applet
  
  public AR_menu(int dx, int dy, Applet ap) // Costruttore
   {
    MODE=Integer.parseInt(ap.getParameter("menumode"));
    MENUTITLE=ap.getParameter("menutitle");
    MENUURL=ap.getParameter("menuurl");
    MENUTARGET=ap.getParameter("menutarget");
    START=Integer.parseInt(ap.getParameter("menupos"));;
    spaz=Integer.parseInt(ap.getParameter("menuspac"));
    SELMODE=Integer.parseInt(ap.getParameter("menuselectmode"));
    col1=new Color(Integer.parseInt(ap.getParameter("menunormalcol"),16));
    col2=new Color(Integer.parseInt(ap.getParameter("menuselectcol"),16));
    col3=new Color(Integer.parseInt(ap.getParameter("menushadowcol"),16));    
    col4=new Color(Integer.parseInt(ap.getParameter("menuboxcol"),16)); 
    SHAD=Integer.parseInt(ap.getParameter("menushadow"));
    tipofont=Integer.parseInt(ap.getParameter("menufont"));
    hfont=Integer.parseInt(ap.getParameter("menufonth"));
    align=Integer.parseInt(ap.getParameter("menualign"));
    
    apDX=dx; apDY=dy;
    spaz/=2; over=-1; sdis=1; inv=0;
    if(tipofont==0) f=new Font("TimesRoman",Font.BOLD,hfont);
    if(tipofont==1) f=new Font("Arial",Font.BOLD,hfont);
    if(tipofont==2) f=new Font("Courier",Font.BOLD,hfont);    
    NUM=tokenizeParams(1);
    titolo = new String[NUM];
    url    = new String[NUM];
    target = new String[NUM];
    offset = new int[NUM];
    tokenizeParams(0);
    hmax=getFontMetrics(f).getHeight();
    for(int i=0;i<NUM;i++) if(wmax<getFontMetrics(f).stringWidth(titolo[i])) wmax=getFontMetrics(f).stringWidth(titolo[i]);
    fgap=START+(getFontMetrics(f).getMaxAscent()>>1);
    fgap=fgap+(hmax>>2)+2+(spaz>>1);
   }
   
  public void drawMenu(Graphics g) // Manda a video il menu
   {
    int posx=0,posy=0;

    g.setFont(f);    
    if(MODE==0) // Menu verticale 
     {
      if(over>=0 && over<NUM)
       {
       	g.setColor(col4);
       	inv++; if(inv>=4) inv=0;
        if(SELMODE==1) g.drawRect(0,over*(hmax+spaz)+START,apDX-1,hmax+spaz);
        if(SELMODE==2) g.fillRect(0,over*(hmax+spaz)+START,apDX,hmax+spaz);
        if(SELMODE==3) if(inv%2==0) g.fillRect(0,over*(hmax+spaz)+START,apDX,hmax+spaz);
       }
      for(int i=0;i<NUM;i++)
       {
        if(align==0) posx=1;
        if(align==1) posx=(apDX-getFontMetrics(f).stringWidth(titolo[i]))>>1;
        if(align==2) posx=apDX-getFontMetrics(f).stringWidth(titolo[i])-3;
        posy=fgap+(i*(hmax+spaz));
        if(SHAD==1) { g.setColor(col3); g.drawString(titolo[i],posx+sdis,posy+sdis); } // Ombra
        if(over!=i)
         {
          g.setColor(col1);
          g.drawString(titolo[i],posx,posy); // Testo
         }
        else
         {
          if(SHAD==1) { g.setColor(col2); g.drawString(titolo[i],posx+sdis,posy+sdis); } // Testo abbassato ed evidenziato
          else        { g.setColor(col2); g.drawString(titolo[i],posx,posy); } // Testo evidenziato
         }
       }
     }
    if(MODE==1) // Menu orizzontale
     {
      if(align==0) posy=(getFontMetrics(f).getMaxAscent()>>1)+(hmax>>2)+1;
      if(align==1) posy=((apDY-hmax)>>1)+(getFontMetrics(f).getMaxAscent()>>1)+(hmax>>2)+1;
      if(align==2) posy=apDY-getFontMetrics(f).getMaxDescent()-3;
      if(over>=0 && over<NUM)
       {
       	inv++; if(inv>=4) inv=0;
       	g.setColor(col4);
        if(SELMODE==1) g.drawRect(offset[over]+spaz*over+START,0,getFontMetrics(f).stringWidth(titolo[over]),apDY-1);
        if(SELMODE==2) g.fillRect(offset[over]+spaz*over+START,0,getFontMetrics(f).stringWidth(titolo[over]),apDY);
        if(SELMODE==3) if(inv%2==0) g.fillRect(offset[over]+spaz*over+START,0,getFontMetrics(f).stringWidth(titolo[over]),apDY);
       }
      for(int i=0;i<NUM;i++)
       {
        posx=offset[i]+spaz*i+START;
        if(SHAD==1) { g.setColor(col3); g.drawString(titolo[i],posx+sdis,posy+sdis); } // Ombra
        if(over!=i)
         {
          g.setColor(col1);
          g.drawString(titolo[i],posx,posy); // Testo
         }
        else
         {
          if(SHAD==1) { g.setColor(col2); g.drawString(titolo[i],posx+sdis,posy+sdis); } // Testo abbassato ed evidenziato
          else        { g.setColor(col2); g.drawString(titolo[i],posx,posy); } // Testo evidenziato
         }
       }
     }
   }

  public void overMenu(int p) // Calcola la voce evidenziata
   {
    int a,b;
    
    if(MODE==0) if(p<START) over=-1; else over=(p-START)/(hmax+spaz); // Menu verticale
    if(MODE==1) // Menu orizzontale
     {
      if(p<START) over=-1;
      else
       {
       	for(int i=0;i<NUM;i++)
       	 {
       	  a=offset[i]+START+i*spaz+getFontMetrics(f).stringWidth(titolo[i]);
       	  if(p>=offset[i]+START+i*spaz && p<=a) over=i;
       	  if(i==0) b=spaz; else b=i*spaz;
       	  if(p>=a && p<=a+b) over=-1;
       	 }
       }
     }
   }
   
 public int tokenizeParams(int fl)
  {
   int i=0,n;   
   StringTokenizer str;
         
   str=new StringTokenizer(MENUTITLE,"|");
   n=str.countTokens();
   if(fl==1) return n;
   else
    {
     while(str.hasMoreTokens())
      {	
       titolo[i]=str.nextToken();
       url[i]="";
       target[i]="_blank";
       if(i==0) offset[i]=0;
       else offset[i]=getFontMetrics(f).stringWidth(titolo[i-1])+offset[i-1];
       i++;
      }
     i=0;
     str=new StringTokenizer(MENUURL,"|");
     while(str.hasMoreTokens() && i<n)
      {
       url[i]=str.nextToken();
       i++;
      }
     i=0;
     str=new StringTokenizer(MENUTARGET,"|");
     while(str.hasMoreTokens() && i<n)
      {
       target[i]=str.nextToken();
       i++;
      }
    }
   return n;
  }
 }
 
class AR_particle // Classe che definisce una particella
 {
  int x,y; // coordinate particella
  int sp;  // velocit particella
  int vx,vy;
  int ac;  // accelerazione particella
  int an;  // angolazione del moto della particella (in gradi)
  int fl;  // flag
  int passi;
  int gr;  // gravit
  int col; // colore botto

  AR_particle()
   {   	
    x=0;
    y=0;
    vx=0;
    vy=0;
    ac=0;
    an=0;
    fl=0;
    gr=0;
    passi=0;
    col=0;
   }

  AR_particle(int x, int y, int ac, int an, int gr, int col)
   {
    this.x=x;
    this.y=y;
    this.vx=0;
    this.vy=0;
    this.ac=ac;
    this.an=an;
    this.fl=0;
    this.passi=0;
    this.gr=gr;
    this.col=col;
   }
   
  void AR_accelera()
   {
    int ax,ay;

    ax=ac*AR_util.ILUTC[an];
    ay=ac*AR_util.ILUTS[an];
    ax=ax-AR_util.AR_rand(65536)+AR_util.AR_rand(65536);
    ay=ay-AR_util.AR_rand(65536)+AR_util.AR_rand(65536);
    ay+=AR_util.AR_rand(gr)*65536;              // gravit lungo y
    
    ax/=16; // DIVIDERE PER UN NUMERO CHE indica il raggio del "botto"
    ay/=16;
    vx+=ax;
    vy+=ay;
    ac=-1;
    passi++;
    if(passi<21)
     { 
      x+=vx;
      y+=vy;
    }
   }
 }